define([], function() {
	sap.m.List.extend("com.sap.sample.ui5list.List", {
		initDesignStudio: function() {
			var showDimensionsButton = new sap.m.Button({
				icon: "sap-icon://settings"
			});
			var that = this;
			showDimensionsButton.attachPress(function() {
				if (that._ds) {
					that.callZTLFunction("getDimensions", function(result) {
						that.setItems(result);
					});					
				}
			});
			var tb = new sap.m.Toolbar();
			tb.addContent(showDimensionsButton);
			this.setHeaderToolbar(tb);
		},
		renderer: {},
		setItems: function(list) {
			this.removeAllItems();
			for (var i = 0; i < list.length; i++) {
				var entry = list[i];
				var item = new sap.m.StandardListItem({
					title: entry.text,
					description: entry.key,
					icon: entry.image
				});
				this.addItem(item);
			}
		},
		setDATA_SOURCE_ALIAS_REF: function(value) {
			this._ds = value;
		}
	});	
});
